%This is the main file in the simulation process.
%The file determines the LSE solution to a positioning problem in a
%bidimensional space.
%It is based on file "cp1002_find_LSE_position" but significant
%changes have been made.
%
%The file no longer functions as a function, that is, all the necessary
%parameters are defined either in posisjonering_hovedfil.m itself or
%posisjonering.m
%
%
% The file generates the estimated position of 
% the target node Nx and the error with respect to the
% exact position ErrNx
% 
%
%Programmed by Luca De Nardis, edited by the author.
%


%Part of the original code by Luca De Neris
%function [PosNx, ErrNx] = cp1002_find_LSE_position(positions, ranges, Nx, Ref,sigma_2, G);
 


n=7                    %Distance between the nodes, described as I=J=K in the report.

zeros(7,2)               
positions(1,1)=0         %A matrix 'positions' is generated containing positions of the nodes
positions(1,2)=0         %placed as described in the report. 
positions(2,1)=-n
positions(2,2)=0
positions(3,1)=-n/2
positions(3,2)=-sqrt(((n^2)-(n/2)^2))
positions(4,1)=n/2
positions(4,2)=-sqrt(((n^2)-(n/2)^2))
positions(5,1)=n
positions(5,2)=0
positions(6,1)=n/2
positions(6,2)=sqrt(((n^2)-(n/2)^2))
positions(7,1)=-n/2
positions(7,2)=sqrt(((n^2)-(n/2)^2))

zeros(7,7)
ranges=zeros(7,7)       %A matrix 'ranges' is generated containing the distances between 
ranges(1,1)=0           %each pair of nodes.
ranges(1,2)=n
ranges(1,3)=n
ranges(1,4)=n
ranges(1,5)=n
ranges(1,6)=n
ranges(1,7)=n
ranges(2,1)=n
ranges(2,2)=0
ranges(2,3)=n
ranges(2,4)=sqrt((n+n/2)^2+((n^2)-(n/2)^2))
ranges(2,5)=2*n
ranges(2,6)=sqrt((n+n/2)^2+((n^2)-(n/2)^2))
ranges(2,7)=n
ranges(3,1)=n
ranges(3,2)=n
ranges(3,3)=0
ranges(3,4)=n
ranges(3,5)=sqrt((n+n/2)^2+((n^2)-(n/2)^2))
ranges(3,6)=2*n
ranges(3,7)=(2*sqrt(((n^2)-(n/2)^2)))
ranges(4,1)=n
ranges(4,2)=sqrt((n+n/2)^2+((n^2)-(n/2)^2))
ranges(4,3)=n
ranges(4,4)=0
ranges(4,5)=n
ranges(4,6)=(2*sqrt(((n^2)-(n/2)^2)))
ranges(4,7)=2*n
ranges(5,1)=n
ranges(5,2)=2*n
ranges(5,3)=sqrt((n+n/2)^2+((n^2)-(n/2)^2))
ranges(5,4)=n
ranges(5,5)=0
ranges(5,6)=n
ranges(5,7)=sqrt((n+n/2)^2+((n^2)-(n/2)^2))
ranges(6,1)=n
ranges(6,2)=sqrt((n+n/2)^2+((n^2)-(n/2)^2))
ranges(6,3)=2*n
ranges(6,4)=(2*sqrt(((n^2)-(n/2)^2)))
ranges(6,5)=n
ranges(6,6)=0
ranges(6,7)=n
ranges(7,1)=n
ranges(7,2)=n
ranges(7,3)=(2*sqrt(((n^2)-(n/2)^2)))
ranges(7,4)=2*n
ranges(7,5)=sqrt((n+n/2)^2+((n^2)-(n/2)^2))
ranges(7,6)=n
ranges(7,7)=0

Nx=1                %Selects the target node.
Ref=[2 3 4 5 6 7]   %Selects the reference nodes
G=1

distanse=ranges(1,2:length(ranges(1,:))) %Estimates the REAL distance between the reference nodes ant the target node.
[estimert_avstand] = posisjonering(distanse) % Uses the real distance 'distanse' 
                                             %to find an estimate of the 
                                             %distanse between the ref.
                                             %nodes and the target node
                                             %using the ranging methods in 'posisjonering.m' 
                                       
                                             

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Uses the LSE method to find the position of the target node based on the
%estimated distance to the reference nodes.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%N = size(ranges,1);
%err_ranges = ranges + sqrt(sigma_2)*randn(N); The error added in the
%original code
err_ranges=zeros((length(Ref)+1),1); 
err_ranges(2:(length(Ref)+1),1)=transpose(estimert_avstand);%the error added through 'posisjonering.m'
%by using 'estimert_avstand'

%%%%%%%%%%%%%%%The rest of the code is unchanged by the author%%%%%%%%

% Defining the linear problem
% Matrix A
k = length(Ref);
for i=1:(k-1)
    A(i,1) = positions(Ref(i),1) - positions(Ref(k),1);
    A(i,2) = positions(Ref(i),2) - positions(Ref(k),2);
end
A=-2*A;
% Matrix b
b=zeros(2,1);
for i=1:(k-1)
    b(i) = err_ranges(Ref(i),Nx)^2 -...
      err_ranges(Ref(k),Nx)^2 - positions(Ref(i),1)^2 +...
      positions(Ref(k),1)^2 - positions(Ref(i),2)^2 +...
      positions(Ref(k),2)^2;
end


% Solving the problem
PosNx=A\b;

%Computing the error
ErrNx = sqrt((PosNx(1)-positions(Nx,1))^2+(PosNx(2)-...
   positions(Nx,2))^2);

%Graphical output
if G
    scatter(positions(:,1),positions(:,2));
    xlabel('X [m]');
    ylabel('Y [m]');
    box on;
    hold on;
    scatter(PosNx(1), PosNx(2), 200, 'filled', 'k','p');
    scatter(positions(Nx,1),positions(Nx,2),200,...
       'filled','^');
    for i=1:k
        scatter(positions(Ref(i),1),positions(Ref(i),2),...
           'filled','r','s');
    end
    hold off;
end
