%
% FUNCTION 8.1 : "cp0801_pathloss"
%
% Attenuates the input signal 'tx' according to
% the distance 'd' [m], the decaying factor 'gamma'
% and the constant term 'c0', which represents the
% reference attenuation at 1 meter.
%
% The function returns the attenuated signal 'rx'
% and the value of the channel gain 'attn'
%
% Programmed by Guerino Giancola
%

function [rx,attn] = cp0801_pathloss(tx,c0,d,gamma)

% -------------------------------
% Step One - Path loss evaluation
% -------------------------------

attn = (c0/sqrt(d^gamma));
rx = attn .* tx;
